/* Paned.c generated by valac 0.56.17, the Vala compiler
 * generated from Paned.vala, do not modify */

/* Paned.vala
 *
 * Copyright (C) 2009-2024 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "font-manager.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_TYPE_PANED (font_manager_paned_get_type ())
#define FONT_MANAGER_PANED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PANED, FontManagerPaned))
#define FONT_MANAGER_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PANED, FontManagerPanedClass))
#define FONT_MANAGER_IS_PANED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PANED))
#define FONT_MANAGER_IS_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PANED))
#define FONT_MANAGER_PANED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PANED, FontManagerPanedClass))

typedef struct _FontManagerPaned FontManagerPaned;
typedef struct _FontManagerPanedClass FontManagerPanedClass;
typedef struct _FontManagerPanedPrivate FontManagerPanedPrivate;
enum  {
	FONT_MANAGER_PANED_0_PROPERTY,
	FONT_MANAGER_PANED_SETTINGS_PROPERTY,
	FONT_MANAGER_PANED_ORIENTATION_PROPERTY,
	FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY,
	FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY,
	FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY,
	FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY,
	FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY,
	FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY,
	FONT_MANAGER_PANED_NUM_PROPERTIES
};
static GParamSpec* font_manager_paned_properties[FONT_MANAGER_PANED_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FontManagerPaned {
	GtkBox parent_instance;
	FontManagerPanedPrivate * priv;
	GtkBox* content_area;
	GtkBox* list_area;
	GtkBox* sidebar_area;
	GtkPaned* content_pane;
	GtkPaned* main_pane;
	GtkOverlay* overlay;
};

struct _FontManagerPanedClass {
	GtkBoxClass parent_class;
	void (*on_map) (FontManagerPaned* self);
	void (*on_unmap) (FontManagerPaned* self);
};

struct _FontManagerPanedPrivate {
	GSettings* _settings;
	gdouble sidebar_pos;
	gdouble content_pos;
	gdouble hor_sidebar_pos;
	gdouble hor_content_pos;
};

static gint FontManagerPaned_private_offset;
static gpointer font_manager_paned_parent_class = NULL;

VALA_EXTERN GType font_manager_paned_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPaned, g_object_unref)
VALA_EXTERN void font_manager_paned_on_map (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_on_unmap (FontManagerPaned* self);
VALA_EXTERN FontManagerPaned* font_manager_paned_new (GSettings* settings);
VALA_EXTERN FontManagerPaned* font_manager_paned_construct (GType object_type,
                                                GSettings* settings);
static void __lambda4_ (FontManagerPaned* self,
                 GObject* obj,
                 GParamSpec* pspec);
static gdouble font_manager_paned_position_to_percentage (FontManagerPaned* self,
                                                   GtkPaned* paned);
VALA_EXTERN GtkOrientation font_manager_paned_get_orientation (FontManagerPaned* self);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda6_ (FontManagerPaned* self,
                 GObject* obj,
                 GParamSpec* pspec);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void font_manager_paned_real_on_map (FontManagerPaned* self);
VALA_EXTERN GSettings* font_manager_paned_get_settings (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_sidebar_position (FontManagerPaned* self,
                                              gdouble value);
VALA_EXTERN void font_manager_paned_set_content_position (FontManagerPaned* self,
                                              gdouble value);
static gboolean __lambda7_ (FontManagerPaned* self);
VALA_EXTERN gboolean font_manager_paned_update_pane_positions (FontManagerPaned* self);
static gboolean ___lambda7__gsource_func (gpointer self);
static void _font_manager_paned_on_map_gtk_widget_map (GtkWidget* _sender,
                                                gpointer self);
static void font_manager_paned_real_on_unmap (FontManagerPaned* self);
static void _font_manager_paned_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                                    gpointer self);
VALA_EXTERN GtkWidget* font_manager_paned_get_content_widget (FontManagerPaned* self);
VALA_EXTERN GtkWidget* font_manager_paned_get_list_widget (FontManagerPaned* self);
VALA_EXTERN GtkWidget* font_manager_paned_get_sidebar_widget (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_content_widget (FontManagerPaned* self,
                                            GtkWidget* widget);
static void font_manager_paned_set_child (FontManagerPaned* self,
                                   GtkBox* parent,
                                   GtkWidget* child);
VALA_EXTERN void font_manager_paned_set_list_widget (FontManagerPaned* self,
                                         GtkWidget* widget);
VALA_EXTERN void font_manager_paned_set_sidebar_widget (FontManagerPaned* self,
                                            GtkWidget* widget);
static gdouble font_manager_paned_percentage_to_position (FontManagerPaned* self,
                                                   GtkPaned* paned,
                                                   gdouble percent);
VALA_EXTERN gdouble font_manager_paned_get_sidebar_position (FontManagerPaned* self);
VALA_EXTERN gdouble font_manager_paned_get_content_position (FontManagerPaned* self);
static gint font_manager_paned_get_alloc (FontManagerPaned* self,
                                   GtkPaned* paned);
VALA_EXTERN void font_manager_paned_set_settings (FontManagerPaned* self,
                                      GSettings* value);
VALA_EXTERN void font_manager_paned_set_orientation (FontManagerPaned* self,
                                         GtkOrientation value);
static gboolean _font_manager_paned_orientation___lambda5_ (FontManagerPaned* self);
static gboolean __font_manager_paned_orientation___lambda5__gsource_func (gpointer self);
VALA_EXTERN gdouble font_manager_paned_get_content_size (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_content_size (FontManagerPaned* self,
                                          gdouble value);
VALA_EXTERN gdouble font_manager_paned_get_sidebar_size (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_sidebar_size (FontManagerPaned* self,
                                          gdouble value);
VALA_EXTERN gdouble font_manager_paned_get_hor_content_size (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_hor_content_size (FontManagerPaned* self,
                                              gdouble value);
VALA_EXTERN gdouble font_manager_paned_get_hor_sidebar_size (FontManagerPaned* self);
VALA_EXTERN void font_manager_paned_set_hor_sidebar_size (FontManagerPaned* self,
                                              gdouble value);
static void font_manager_paned_finalize (GObject * obj);
static GType font_manager_paned_get_type_once (void);
static void _vala_font_manager_paned_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_font_manager_paned_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
font_manager_paned_get_instance_private (FontManagerPaned* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerPaned_private_offset);
}

static void
__lambda4_ (FontManagerPaned* self,
            GObject* obj,
            GParamSpec* pspec)
{
	gdouble new_pos = 0.0;
	GtkPaned* _tmp0_;
	GtkOrientation _tmp1_;
	GtkOrientation _tmp2_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = self->main_pane;
	new_pos = CLAMP (font_manager_paned_position_to_percentage (self, _tmp0_), (gdouble) 2, (gdouble) 98);
	_tmp1_ = font_manager_paned_get_orientation (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == GTK_ORIENTATION_HORIZONTAL) {
		self->priv->hor_sidebar_pos = new_pos;
		g_object_notify ((GObject*) self, "hor-sidebar-size");
	} else {
		self->priv->sidebar_pos = new_pos;
		g_object_notify ((GObject*) self, "sidebar-size");
	}
	g_object_notify ((GObject*) self, "sidebar-position");
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda4_ ((FontManagerPaned*) self, _sender, pspec);
}

static void
__lambda6_ (FontManagerPaned* self,
            GObject* obj,
            GParamSpec* pspec)
{
	gdouble new_pos = 0.0;
	GtkPaned* _tmp0_;
	GtkOrientation _tmp1_;
	GtkOrientation _tmp2_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = self->content_pane;
	new_pos = CLAMP (font_manager_paned_position_to_percentage (self, _tmp0_), (gdouble) 2, (gdouble) 98);
	_tmp1_ = font_manager_paned_get_orientation (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == GTK_ORIENTATION_HORIZONTAL) {
		self->priv->hor_content_pos = new_pos;
		g_object_notify ((GObject*) self, "hor-content-size");
	} else {
		self->priv->content_pos = new_pos;
		g_object_notify ((GObject*) self, "content-size");
	}
	g_object_notify ((GObject*) self, "content-position");
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ ((FontManagerPaned*) self, _sender, pspec);
}

FontManagerPaned*
font_manager_paned_construct (GType object_type,
                              GSettings* settings)
{
	FontManagerPaned * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkPaned* _tmp2_;
	GtkPaned* _tmp3_;
	self = (FontManagerPaned*) g_object_new (object_type, "settings", settings, NULL);
	_tmp0_ = self->sidebar_area;
	gtk_widget_set_size_request ((GtkWidget*) _tmp0_, -1, 250);
	_tmp1_ = self->list_area;
	gtk_widget_set_size_request ((GtkWidget*) _tmp1_, -1, 250);
	_tmp2_ = self->main_pane;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::position", (GCallback) ___lambda4__g_object_notify, self, 0);
	_tmp3_ = self->content_pane;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::position", (GCallback) ___lambda6__g_object_notify, self, 0);
	return self;
}

FontManagerPaned*
font_manager_paned_new (GSettings* settings)
{
	return font_manager_paned_construct (FONT_MANAGER_TYPE_PANED, settings);
}

static gboolean
__lambda7_ (FontManagerPaned* self)
{
	gboolean result;
	font_manager_paned_update_pane_positions (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ ((FontManagerPaned*) self);
	return result;
}

static void
font_manager_paned_real_on_map (FontManagerPaned* self)
{
	GSettings* _tmp0_;
	_tmp0_ = self->priv->_settings;
	if (_tmp0_ != NULL) {
		GSettingsBindFlags flags = 0U;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		GtkOrientation _tmp5_;
		GtkOrientation _tmp6_;
		flags = G_SETTINGS_BIND_DEFAULT;
		_tmp1_ = self->priv->_settings;
		g_settings_bind (_tmp1_, "sidebar-size", (GObject*) self, "sidebar-size", flags);
		_tmp2_ = self->priv->_settings;
		g_settings_bind (_tmp2_, "content-size", (GObject*) self, "content-size", flags);
		_tmp3_ = self->priv->_settings;
		g_settings_bind (_tmp3_, "hor-sidebar-size", (GObject*) self, "hor-sidebar-size", flags);
		_tmp4_ = self->priv->_settings;
		g_settings_bind (_tmp4_, "hor-content-size", (GObject*) self, "hor-content-size", flags);
		_tmp5_ = font_manager_paned_get_orientation (self);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == GTK_ORIENTATION_HORIZONTAL) {
			GSettings* _tmp7_;
			GSettings* _tmp8_;
			_tmp7_ = self->priv->_settings;
			font_manager_paned_set_sidebar_position (self, g_settings_get_double (_tmp7_, "hor-sidebar-size"));
			_tmp8_ = self->priv->_settings;
			font_manager_paned_set_content_position (self, g_settings_get_double (_tmp8_, "hor-content-size"));
		} else {
			GSettings* _tmp9_;
			GSettings* _tmp10_;
			_tmp9_ = self->priv->_settings;
			font_manager_paned_set_sidebar_position (self, g_settings_get_double (_tmp9_, "sidebar-size"));
			_tmp10_ = self->priv->_settings;
			font_manager_paned_set_content_position (self, g_settings_get_double (_tmp10_, "content-size"));
		}
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, g_object_ref (self), g_object_unref);
	g_object_notify ((GObject*) self, "sidebar-position");
	g_object_notify ((GObject*) self, "content-position");
	return;
}

void
font_manager_paned_on_map (FontManagerPaned* self)
{
	FontManagerPanedClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = FONT_MANAGER_PANED_GET_CLASS (self);
	if (_klass_->on_map) {
		_klass_->on_map (self);
	}
}

static void
_font_manager_paned_on_map_gtk_widget_map (GtkWidget* _sender,
                                           gpointer self)
{
	font_manager_paned_on_map ((FontManagerPaned*) self);
}

static void
font_manager_paned_real_on_unmap (FontManagerPaned* self)
{
}

void
font_manager_paned_on_unmap (FontManagerPaned* self)
{
	FontManagerPanedClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = FONT_MANAGER_PANED_GET_CLASS (self);
	if (_klass_->on_unmap) {
		_klass_->on_unmap (self);
	}
}

static void
_font_manager_paned_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                               gpointer self)
{
	font_manager_paned_on_unmap ((FontManagerPaned*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GtkWidget*
font_manager_paned_get_content_widget (FontManagerPaned* self)
{
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->content_area;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

GtkWidget*
font_manager_paned_get_list_widget (FontManagerPaned* self)
{
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->list_area;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

GtkWidget*
font_manager_paned_get_sidebar_widget (FontManagerPaned* self)
{
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->sidebar_area;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

void
font_manager_paned_set_content_widget (FontManagerPaned* self,
                                       GtkWidget* widget)
{
	GtkBox* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->content_area;
	font_manager_paned_set_child (self, _tmp0_, widget);
	return;
}

void
font_manager_paned_set_list_widget (FontManagerPaned* self,
                                    GtkWidget* widget)
{
	GtkBox* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->list_area;
	font_manager_paned_set_child (self, _tmp0_, widget);
	return;
}

void
font_manager_paned_set_sidebar_widget (FontManagerPaned* self,
                                       GtkWidget* widget)
{
	GtkBox* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->sidebar_area;
	font_manager_paned_set_child (self, _tmp0_, widget);
	return;
}

static void
font_manager_paned_set_child (FontManagerPaned* self,
                              GtkBox* parent,
                              GtkWidget* child)
{
	GtkWidget* current_child = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) parent);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	current_child = _tmp1_;
	_tmp2_ = current_child;
	if (_tmp2_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = current_child;
		gtk_box_remove (parent, _tmp3_);
	}
	if (child != NULL) {
		font_manager_widget_set_expand (child, TRUE);
		gtk_box_append (parent, child);
	}
	_g_object_unref0 (current_child);
	return;
}

gboolean
font_manager_paned_update_pane_positions (FontManagerPaned* self)
{
	gint pos_a = 0;
	GtkPaned* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint pos_b = 0;
	GtkPaned* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkPaned* _tmp7_;
	GtkPaned* _tmp8_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->main_pane;
	_tmp1_ = font_manager_paned_get_sidebar_position (self);
	_tmp2_ = _tmp1_;
	pos_a = (gint) font_manager_paned_percentage_to_position (self, _tmp0_, _tmp2_);
	_tmp3_ = self->content_pane;
	_tmp4_ = font_manager_paned_get_content_position (self);
	_tmp5_ = _tmp4_;
	pos_b = (gint) font_manager_paned_percentage_to_position (self, _tmp3_, _tmp5_);
	if (pos_a == 0) {
		_tmp6_ = pos_b == 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		result = G_SOURCE_REMOVE;
		return result;
	}
	_tmp7_ = self->main_pane;
	gtk_paned_set_position (_tmp7_, pos_a);
	_tmp8_ = self->content_pane;
	gtk_paned_set_position (_tmp8_, pos_b);
	result = G_SOURCE_REMOVE;
	return result;
}

static gint
font_manager_paned_get_alloc (FontManagerPaned* self,
                              GtkPaned* paned)
{
	gint alloc = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
	GtkOrientation _tmp3_;
	GtkOrientation _tmp4_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (paned != NULL, 0);
	g_object_get (paned, "max-position", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	alloc = _tmp1_;
	if (alloc != G_MAXINT) {
		result = alloc;
		return result;
	}
	_tmp3_ = gtk_orientable_get_orientation ((GtkOrientable*) paned);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == GTK_ORIENTATION_HORIZONTAL) {
		_tmp2_ = gtk_widget_get_width ((GtkWidget*) paned);
	} else {
		_tmp2_ = gtk_widget_get_height ((GtkWidget*) paned);
	}
	result = _tmp2_;
	return result;
}

static gdouble
font_manager_paned_position_to_percentage (FontManagerPaned* self,
                                           GtkPaned* paned)
{
	gint position = 0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (paned != NULL, 0.0);
	_tmp0_ = gtk_paned_get_position (paned);
	_tmp1_ = _tmp0_;
	position = _tmp1_;
	result = (((gdouble) position) / ((gdouble) font_manager_paned_get_alloc (self, paned))) * 100;
	return result;
}

static gdouble
font_manager_paned_percentage_to_position (FontManagerPaned* self,
                                           GtkPaned* paned,
                                           gdouble percent)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (paned != NULL, 0.0);
	result = (percent / 100) * ((gdouble) font_manager_paned_get_alloc (self, paned));
	return result;
}

GSettings*
font_manager_paned_get_settings (FontManagerPaned* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

void
font_manager_paned_set_settings (FontManagerPaned* self,
                                 GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_paned_get_settings (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_SETTINGS_PROPERTY]);
	}
}

GtkOrientation
font_manager_paned_get_orientation (FontManagerPaned* self)
{
	GtkOrientation result;
	GtkPaned* _tmp0_;
	GtkOrientation _tmp1_;
	GtkOrientation _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->content_pane;
	_tmp1_ = gtk_orientable_get_orientation ((GtkOrientable*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static gboolean
_font_manager_paned_orientation___lambda5_ (FontManagerPaned* self)
{
	gboolean result;
	font_manager_paned_update_pane_positions (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
__font_manager_paned_orientation___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = _font_manager_paned_orientation___lambda5_ ((FontManagerPaned*) self);
	return result;
}

void
font_manager_paned_set_orientation (FontManagerPaned* self,
                                    GtkOrientation value)
{
	GtkPaned* _tmp0_;
	GtkOrientation _tmp1_;
	GtkOrientation _tmp2_;
	GtkPaned* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->content_pane;
	_tmp1_ = gtk_orientable_get_orientation ((GtkOrientable*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (value == _tmp2_) {
		return;
	}
	_tmp3_ = self->content_pane;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp3_, value);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __font_manager_paned_orientation___lambda5__gsource_func, g_object_ref (self), g_object_unref);
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_ORIENTATION_PROPERTY]);
}

gdouble
font_manager_paned_get_sidebar_position (FontManagerPaned* self)
{
	gdouble result;
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = font_manager_paned_get_orientation (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
		result = self->priv->hor_sidebar_pos;
		return result;
	} else {
		result = self->priv->sidebar_pos;
		return result;
	}
}

void
font_manager_paned_set_sidebar_position (FontManagerPaned* self,
                                         gdouble value)
{
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = font_manager_paned_get_orientation (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
		self->priv->hor_sidebar_pos = value;
	} else {
		self->priv->sidebar_pos = value;
	}
	font_manager_paned_update_pane_positions (self);
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY]);
}

gdouble
font_manager_paned_get_content_position (FontManagerPaned* self)
{
	gdouble result;
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = font_manager_paned_get_orientation (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
		result = self->priv->hor_content_pos;
		return result;
	} else {
		result = self->priv->content_pos;
		return result;
	}
}

void
font_manager_paned_set_content_position (FontManagerPaned* self,
                                         gdouble value)
{
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = font_manager_paned_get_orientation (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
		self->priv->hor_content_pos = value;
	} else {
		self->priv->content_pos = value;
	}
	font_manager_paned_update_pane_positions (self);
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY]);
}

gdouble
font_manager_paned_get_content_size (FontManagerPaned* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->content_pos;
	return result;
}

void
font_manager_paned_set_content_size (FontManagerPaned* self,
                                     gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->content_pos = value;
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY]);
}

gdouble
font_manager_paned_get_sidebar_size (FontManagerPaned* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->sidebar_pos;
	return result;
}

void
font_manager_paned_set_sidebar_size (FontManagerPaned* self,
                                     gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->sidebar_pos = value;
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY]);
}

gdouble
font_manager_paned_get_hor_content_size (FontManagerPaned* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->hor_content_pos;
	return result;
}

void
font_manager_paned_set_hor_content_size (FontManagerPaned* self,
                                         gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->hor_content_pos = value;
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY]);
}

gdouble
font_manager_paned_get_hor_sidebar_size (FontManagerPaned* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->hor_sidebar_pos;
	return result;
}

void
font_manager_paned_set_hor_sidebar_size (FontManagerPaned* self,
                                         gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->hor_sidebar_pos = value;
	g_object_notify_by_pspec ((GObject *) self, font_manager_paned_properties[FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY]);
}

static void
font_manager_paned_class_init (FontManagerPanedClass * klass,
                               gpointer klass_data)
{
	font_manager_paned_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerPaned_private_offset);
	((FontManagerPanedClass *) klass)->on_map = (void (*) (FontManagerPaned*)) font_manager_paned_real_on_map;
	((FontManagerPanedClass *) klass)->on_unmap = (void (*) (FontManagerPaned*)) font_manager_paned_real_on_unmap;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_paned_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_paned_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_paned_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_SETTINGS_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_ORIENTATION_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_ORIENTATION_PROPERTY] = g_param_spec_enum ("orientation", "orientation", "orientation", gtk_orientation_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY] = g_param_spec_double ("sidebar-position", "sidebar-position", "sidebar-position", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY] = g_param_spec_double ("content-position", "content-position", "content-position", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY] = g_param_spec_double ("content-size", "content-size", "content-size", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY] = g_param_spec_double ("sidebar-size", "sidebar-size", "sidebar-size", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY] = g_param_spec_double ("hor-content-size", "hor-content-size", "hor-content-size", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY, font_manager_paned_properties[FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY] = g_param_spec_double ("hor-sidebar-size", "hor-sidebar-size", "hor-sidebar-size", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/FontManager/FontManager/ui/font-manager-paned.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_area", FALSE, G_STRUCT_OFFSET (FontManagerPaned, content_area));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_area", FALSE, G_STRUCT_OFFSET (FontManagerPaned, list_area));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sidebar_area", FALSE, G_STRUCT_OFFSET (FontManagerPaned, sidebar_area));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_pane", FALSE, G_STRUCT_OFFSET (FontManagerPaned, content_pane));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_pane", FALSE, G_STRUCT_OFFSET (FontManagerPaned, main_pane));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay", FALSE, G_STRUCT_OFFSET (FontManagerPaned, overlay));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_map", G_CALLBACK(_font_manager_paned_on_map_gtk_widget_map));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_unmap", G_CALLBACK(_font_manager_paned_on_unmap_gtk_widget_unmap));
}

static void
font_manager_paned_instance_init (FontManagerPaned * self,
                                  gpointer klass)
{
	self->priv = font_manager_paned_get_instance_private (self);
	self->priv->_settings = NULL;
	self->priv->sidebar_pos = 33.0;
	self->priv->content_pos = 40.0;
	self->priv->hor_sidebar_pos = 20.0;
	self->priv->hor_content_pos = 36.0;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
font_manager_paned_finalize (GObject * obj)
{
	FontManagerPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_PANED, FontManagerPaned);
	_g_object_unref0 (self->priv->_settings);
	G_OBJECT_CLASS (font_manager_paned_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_paned_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerPanedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_paned_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerPaned), 0, (GInstanceInitFunc) font_manager_paned_instance_init, NULL };
	GType font_manager_paned_type_id;
	font_manager_paned_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerPaned", &g_define_type_info, 0);
	FontManagerPaned_private_offset = g_type_add_instance_private (font_manager_paned_type_id, sizeof (FontManagerPanedPrivate));
	return font_manager_paned_type_id;
}

GType
font_manager_paned_get_type (void)
{
	static volatile gsize font_manager_paned_type_id__once = 0;
	if (g_once_init_enter (&font_manager_paned_type_id__once)) {
		GType font_manager_paned_type_id;
		font_manager_paned_type_id = font_manager_paned_get_type_once ();
		g_once_init_leave (&font_manager_paned_type_id__once, font_manager_paned_type_id);
	}
	return font_manager_paned_type_id__once;
}

static void
_vala_font_manager_paned_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	FontManagerPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_PANED, FontManagerPaned);
	switch (property_id) {
		case FONT_MANAGER_PANED_SETTINGS_PROPERTY:
		g_value_set_object (value, font_manager_paned_get_settings (self));
		break;
		case FONT_MANAGER_PANED_ORIENTATION_PROPERTY:
		g_value_set_enum (value, font_manager_paned_get_orientation (self));
		break;
		case FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_sidebar_position (self));
		break;
		case FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_content_position (self));
		break;
		case FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_content_size (self));
		break;
		case FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_sidebar_size (self));
		break;
		case FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_hor_content_size (self));
		break;
		case FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_paned_get_hor_sidebar_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_paned_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	FontManagerPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_PANED, FontManagerPaned);
	switch (property_id) {
		case FONT_MANAGER_PANED_SETTINGS_PROPERTY:
		font_manager_paned_set_settings (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_PANED_ORIENTATION_PROPERTY:
		font_manager_paned_set_orientation (self, g_value_get_enum (value));
		break;
		case FONT_MANAGER_PANED_SIDEBAR_POSITION_PROPERTY:
		font_manager_paned_set_sidebar_position (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_PANED_CONTENT_POSITION_PROPERTY:
		font_manager_paned_set_content_position (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_PANED_CONTENT_SIZE_PROPERTY:
		font_manager_paned_set_content_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_PANED_SIDEBAR_SIZE_PROPERTY:
		font_manager_paned_set_sidebar_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_PANED_HOR_CONTENT_SIZE_PROPERTY:
		font_manager_paned_set_hor_content_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_PANED_HOR_SIDEBAR_SIZE_PROPERTY:
		font_manager_paned_set_hor_sidebar_size (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

